;***************************************************************************
;
; File Name		:'kernel.asm"
; Title			:ATmega kernel
; Date			:2004.03.19.
; Version		:1.0.0
; Support telephone	:+36-70-333-4034,  old: +36-30-9541-658 VFX
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:AVR
;
;***************************************************************************
;	D E S C R I P T I O N
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  	why
;	----	----------  ---		------------------------------------
;	0.01	2004.03.19  VFX		Creation
;
;***************************************************************************
;Hardware
;***************************************************************************
;*
;*	SYSCLK: f=16.000 MHz (T= 62.5 ns)
;*
;***************************************************************************
;
;
;**************************************************************************
;* Hardware Def.
;
;***************************************************************************
;**** VARIABLES
.DSEG

NxtProcessID:	.byte 2		;A kovetkezo szabad Process Number


;***************************************************************************
.ESEG


;***************************************************************************
;**** CODE SEG
;***************************************************************************
.CSEG

Kernel_Init:
		clr	R16
		sts	NxtProcessID+0,R16
		sts	NxtProcessID+1,R16
		ret

CreateNewProcessId:
		lds	ZL,NxtProcessID+0
		lds	ZH,NxtProcessID+1
		movw	R16,ZL
		adiw	ZL,1
		andi	ZH,ProcMask		;max process number is 0x0FFF
		sts	NxtProcessID+0,ZL
		sts	NxtProcessID+1,ZH
		ret



